// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by an AGPL-3.0-style license
// that can be found in the LICENSE file.

part of omnitest.data;

/// Use case data
class OmnitestUseCase {
  /// Description YAML key
  static const descriptionKey = 'description';

  /// Messages YAML key
  static const messagesKey = 'messages';

  /// Specific description
  String description;

  /// Chain of messages that are successively tested.
  List<OmnitestChainMessage> messageChain = new List<OmnitestChainMessage>();

  /// Load data from a YAML map.
  OmnitestUseCase.fromYaml(
      YamlMap yamlData, Map<String, OmnibuildMessage> messageSpec) {
    // Read description.
    description =
        yamlData.containsKey(descriptionKey) ? yamlData[descriptionKey] : '';

    // Loop through messages.
    if (yamlData.containsKey(messagesKey) &&
        yamlData[messagesKey] is YamlList) {
      yamlData[messagesKey].forEach((YamlMap yamlData) {
        messageChain
            .add(new OmnitestChainMessage.fromYaml(yamlData, messageSpec));
      });
    }
  }
}
