// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by an AGPL-3.0-style license
// that can be found in the LICENSE file.

// THIS FILE IS AUTO-GENERATED, PLEASE DO NOT MODIFY BY HAND.

part of omnitest.test.messages;

/// Messages for simple calculation commands.

/// Calculation request message
class CalculationRequest extends OmnibusRequest {
  /// omnibusId
  static const id = 'omnitest.v0.CalculationRequest';

  /// First input
  final double a;

  /// Second input
  final double b;

  /// Mathematical operator
  final CalculationOperator op;

  /// Constructor
  CalculationRequest(
      [this.a = 1.0, this.b = 1.0, this.op = CalculationOperator.add])
      : super(id);

  /// Construct from passive data structure.
  factory CalculationRequest.fromPds(final Map<String, dynamic> pds) {
    double a;
    double b;
    CalculationOperator op;

    // Read a.
    if (pds.containsKey('a') && pds['a'] is double) {
      a = pds['a'] as double;
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'a'");
    }

    // Read b.
    if (pds.containsKey('b') && pds['b'] is double) {
      b = pds['b'] as double;
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'b'");
    }

    // Read op.
    if (pds.containsKey('op') && pds['op'] is int) {
      op = CalculationOperator.values[pds['op']];
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'op'");
    }

    return new CalculationRequest(a, b, op);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'a': a, 'b': b, 'op': op.index};
  }
}

/// Message handler for CalculationRequest
class CalculationRequestHandler extends OmnibusRequestHandler {
  /// Callback
  final OmnibusRequestCallback<CalculationRequest> _callback;

  /// Mathematical operator
  final CalculationOperator op;

  /// Constructor
  CalculationRequestHandler(this._callback, StateData state, {this.op: null})
      : super(CalculationRequest.id, state);

  /// Process incoming message.
  Future<List<Future<OmnibusResponse>>> process(OmnibusRequest data) async {
    CalculationRequest message = data is CalculationRequest
        ? data
        : new CalculationRequest.fromPds(data.toPds());

    if ((op == null || op == message.op)) {
      return [_callback(message, state)];
    } else {
      return [];
    }
  }
}

/// Calculation request response
class CalculationResponse extends OmnibusResponse {
  /// omnibusId
  static const id = 'omnitest.v0.CalculationResponse';

  /// Calculation result
  final CalculationResult result;

  /// Constructor
  CalculationResponse(this.result) : super(id);

  /// Construct from passive data structure.
  factory CalculationResponse.fromPds(final Map<String, dynamic> pds) {
    CalculationResult result;

    // Read result.
    if (pds.containsKey('result') && pds['result'] is Map) {
      result = new CalculationResult.fromPds(
          new Map<String, double>.from(pds['result']));
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'result'");
    }

    return new CalculationResponse(result);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'result': result.toPds()};
  }
}

/// Create CalculationResponse Stream from the given responses.
Stream<CalculationResponse> streamCalculationResponse(
    OmnibusResponses responses) {
  return responses.stream(
          CalculationResponse.id,
          (OmnibusResponse data) => data is CalculationResponse
              ? data
              : new CalculationResponse.fromPds(data.toPds()))
      as Stream<CalculationResponse>;
}
