// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by an AGPL-3.0-style license
// that can be found in the LICENSE file.

library omnitest.test.messages;

import 'dart:async';

import 'package:omnibus/omnibus.dart';
import 'package:passive_data/passive_data.dart';

part 'calculator.v0.dart';

/// Simple calculation types
enum CalculationOperator { add, subtract, multiply, divide }

/// Calculation result
class CalculationResult {
  final double result;
  CalculationResult(this.result);
  factory CalculationResult.fromPds(Map<String, double> pds) {
    var intMap = pdsToIntMap(pds);
    return new CalculationResult(intMap[0]);
  }
  Map<String, double> toPds() => pdsFromMap({0: result}) as Map<String, double>;
}
